using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using GHI.Pins;


namespace PANDA_3_OW_DS18B20
{
    public class Program
    {
        public static void Main()
        {
            // Change this your correct pin!           
            var Pin = new OutputPort(FEZPandaIII.Gpio.D5, false);

            OneWire DS18B20 = new OneWire(Pin);
            ushort temperature;

            // read every second
            while (true)
            {
                if (DS18B20.TouchReset()!=0) // 
                {
                    DS18B20.WriteByte(0xCC);     // Skip ROM, we only have one device
                    DS18B20.WriteByte(0x44);     // Start temperature conversion

                    while (DS18B20.ReadByte() == 0) ;   // wait while busy

                    DS18B20.TouchReset();
                    DS18B20.WriteByte(0xCC);     // skip ROM
                    DS18B20.WriteByte(0xBE);     // Read Scratchpad

                    temperature = (byte)DS18B20.ReadByte();           // LSB 
                    temperature |= (ushort)(DS18B20.ReadByte() << 8); // MSB

                    Debug.Print("Temperature: " + temperature / 16);
                    Thread.Sleep(1000);
                }
                else
                {
                    Debug.Print("Device is not detected.");
                }

                Thread.Sleep(1000);
            }
        }
    }
}
